;Real Time Clock (RTC) erstmalig stellen und auslesen

RTC_Neustart:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat,Sek_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, C_Start			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	
	ret

RTC_Write:								;und Speicherung im SRAM
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat,Sek_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Sekunden			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Minuten		
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Stunden			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Wochentag		
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Datum		
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Monat			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte
	
	ldi 	tempdat, Jahr			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben
	ret

RTC_Read:									;Anfangswerte auslesen und speichern
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp						;Startbedingung ausgeben
	rcall	Warte							;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat					;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp						;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat,Sek_Register			
	out		TWDR, tempdat					;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp						;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp						;Startbedingung ausgeben
	rcall	Warte							;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat					;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp						;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	ldi 	ZL,low(Sek_Z)					;Zeiger auf SRAM-Location "Sekunden"
	ldi 	ZH,high(Sek_Z)

	ldi 	RTCCnt,6						;Zhler bis Monat

Read_Loop:
	in		tempdat, TWDR					;Daten auslesen
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp						
	rcall	Warte	

	mov 	temp,tempdat
	rcall	BCD_Aufl	
	dec 	RTCCnt							;Register Monat gelesen?
	brne 	Read_Loop						

	in		tempdat, TWDR					;Jahr auslesen
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	mov 	temp,tempdat
	rcall	BCD_Aufl	

;STOP
	ldi		temp, (1<<TWINT | 1<<TWSTO | 1<<TWEN)
	out		TWCR, temp						;Stoppbedingung ausgeben
	ret
